/*
    menu - header
*/
import $ from '../../util/dom-core.js'
import DropList from '../droplist.js'

// 构造函数
function Column(editor) {
    this.editor = editor
    this.$elem = $('<div class="lsiten-e-menu">分栏</div>')
    this.type = 'droplist'

    // 当前是否 active 状态
    this._active = false

    // 初始化 droplist
    this.droplist = new DropList(this, {
        width: 100,
        $title: $('<p>栏数</p>'),
        type: 'list', // droplist 以列表形式展示
        list: [
            { $elem: $('<p>一栏</p>'), value: 'one' },
            { $elem: $('<p>二栏</p>'), value: 'two' },
            { $elem: $('<p>三栏</p>'), value: 'three' },
        ],
        onClick: (value) => {
            this._command(value)
        }
    })
}

// 原型
Column.prototype = {
    constructor: Column,

    // 执行命令
    _command: function (value) {
        let funName = 'lsiten_' + value;
        if (this[funName]) {
          this[funName]();
        }
    },
    lsiten_one: function () {
      const editor = this.editor;
      editor.cmd.do('column', 1);
    },
    lsiten_two: function () {
      const editor = this.editor;
      editor.cmd.do('column', 2);
    },
    lsiten_three: function () {
      const editor = this.editor;
      editor.cmd.do('column', 3);
    }
}

export default Column