/*
    underline-menu
*/
import $ from '../../util/dom-core.js'

// 构造函数
function Underline(editor) {
    this.editor = editor
    this.$elem = $(
        `<div class="lsiten-e-menu">
            <i class="lsiten-e-icon-underline"></i>
        </div>`
    )
    this.type = 'click'

    // 当前是否 active 状态
    this._active = false
}

// 原型
Underline.prototype = {
    constructor: Underline,

    // 点击事件
    onClick: function (e) {
        // 点击菜单将触发这里
        
        const editor = this.editor
        const isSeleEmpty = editor.selection.isSelectionEmpty()

        if (isSeleEmpty) {
            // 选区是空的，插入并选中一个“空白”
            editor.selection.createEmptyRange()
        }
        let text =editor.selection.getRange();
        let startText = text.startContainer;
        if (startText.nodeType === 3) {
          let parentNode = startText.parentNode;
          let nextNode =startText.nextSibling;
          let span = document.createElement('span');
          span.style.textDecoration = 'underline';
          span.appendChild(startText);
          if (nextNode) {
            parentNode.insertBefore(span, nextNode);
          } else {
            parentNode.appendChild(span);
          }
          // 最后，恢复选取保证光标在原来的位置闪烁
          editor.selection.getRange().setStart(span, 1);
        } else {
          let html = '<span style="text-decoration: underline;">&#8203;</span>';
          editor.cmd.do('insertHTML', html);
        }
        editor.selection.saveRange();
        editor.selection.restoreSelection();
        // 执行 underline 命令
        // let result = editor.cmd.do('underline');
        if (isSeleEmpty) {
            // 需要将选取折叠起来
            editor.selection.collapseRange()
            editor.selection.restoreSelection()
        }
    },

    // 试图改变 active 状态
    tryChangeActive: function (e) {
        const editor = this.editor
        const $elem = this.$elem
        if (editor.cmd.queryCommandState('underline')) {
            this._active = true
            $elem.addClass('lsiten-e-active')
        } else {
            this._active = false
            $elem.removeClass('lsiten-e-active')
        }
    }
}

export default Underline