/**
 * 待完善
 */
import '../../less/message.less'
import $ from './dom-core.js';
let options = {
  mask: {
    backgroundColor: 'rgb(0, 0, 0)',
    opacity: 0.8,
    zIndex: 9999
  },
  backgroundColor: '#fff',
  width: 200,
  height: 100,
  timeout: 2000
}
let Message = function (editor, customOptions) {
  this.editor = editor;
  this.$el = $('<div class="lsiten-e-message"></div>');
  this.$mask = $('<div class="lsiten-e-message-mask"></div>');
  this.options = Object.assign({}, options, customOptions || {});
  this._init();
}

Message.prototype = {
  constructor: Message,
  _init: function () {
    let editor = this.editor;
    let styleType = '_initStyle' + this.type;
    this._initBaseStyle();
    if (this[styleType]) {
      this[styleType]();
    }
    this._initEvents();
    editor.$container.append(this.$el);
    editor.$container.append(this.$mask);
  },
  _initOptions() {
    this.type = this.options.type || 'message';
    this.message = this.options.message || '';
  },
  _initBaseStyle: function () {
    this.$mask.css('background-color', this.options.mask.backgroundColor)
              .css('z-index', this.options.mask.zIndex)
              .css('opacity', this.options.mask.opacity)
              .css('top', 0)
              .css('left', 0)
              .css('width', '100%')
              .css('height', '100%')
              .css('position', 'fixed')
              .css('pointer-events', 'auto')
              .css('display', 'none')
    this.$el.css('background-color', this.options.backgroundColor)
            .css('z-index', (this.options.mask.zIndex + 1))
            .css('top', '50%')
            .css('left', '50%')
            .css('transform', 'translate(' + (-this.options.width/2) + 'px,' + (-this.options.height/2) + 'px)')
            .css('width', this.options.width + 'px')
            .css('min-height', this.options.height + 'px')
            .css('height',  'auto')
            .css('position', 'fixed')
            .css('pointer-events', 'auto')
            .css('display', 'none')
  },
  _initShowMessage: function () {
    this.$el.css('transform', 'translate(' + (-this.options.width/2) + 'px,' + (-this.options.height/2) + 'px)')
            .css('width', this.options.width + 'px')
            .css('min-height', this.options.height + 'px')
            .css('height',  'auto')
  },
  _initHeader: function () {
    this.$header = $('<div class="lsiten-e-message-header"></div>');
    let headerType = '_initHeader' + this.type;
    if (this[headerType]) {
      this[headerType]();
    }
  },
  _initBody: function () {
    this.$body = $('<div class="lsiten-e-message-body"></div>');
    let bodyType = '_initBody' + this.type;
    if (this[bodyType]) {
      this[bodyType]();
    }
  },
  _initEvents: function () {
    let _this = this;
    function hidenMessage() {
      _this.$mask.hide();
      _this.$el.hide();
    }
    this.$mask.on('click', hidenMessage)
  },
  // message start
  _initBodymessage: function () {
    let $message = $('<div class="lsiten-e-message-body-content"></div>');
    $message.css('line-height', '30px')
            .css('text-align', 'center')
            .css('margin', '5px 0')
            .css('padding', '0 10px')
    $message.html(this.message);
    this.$el.html('');
    this.$el.append($message);
  },
  _initHeadermessage: function () {

  },
  _initStylemessage: function () {
    this.$el.css('right', '10px')
            .css('top', '10px')
            .css('left', 'inherit')
            .css('background-color', 'rgb(0,0,0)')
            .css('box-shadow', '0 0 10px 0 rgba(0, 0, 0, 0.5)')
            .css('border-radius', '3px')
            .css('opacity', '0.8')
            .css('width', 'auto')
            .css('height', 'auto')
            .css('color', '#fff')
            .css('min-width', '100px')
            .css('min-height', '40px')
            .css('transform', 'none')
  },



    // message start
  _initBodydialog: function () {
    let _this = this;
    let $message = $('<div class="lsiten-e-message-body-content"></div>');
    let content = this.options.content || '';
    if (typeof content === 'string') {
      $message.html(content);
    } else {
      $message.append(content);
    }
    let $button = $('<div class="lsiten-e-message-button"></div>');
    let $buttons = this.options.$buttons;
    if ($buttons) {
      for (let i =0; i< $buttons.length; i++) {
        $button.append($buttons[i]);
      }
    } else {
       let $buttonDom1 = $('<span class="lsiten-message-button lsiten-message-cancel-button">取消</span>');
       let $buttonDom2 = $('<span class="lsiten-message-button lsiten-message-success-button">确定</span>');

       $buttonDom1.on('click', function() {
        _this.hideMessage();
       })
       $buttonDom2.on('click', function() {
        _this.hideMessage();
       })
       $button.append($buttonDom1);
       $button.append($buttonDom2);
    }
    this.$el.append($message);
    this.$el.append($button);
  },
  _initHeaderdialog: function () {
    let _this = this;
    let $header = $('<div class="lsiten-dialog-header"></div>');
    $header.css('padding', '0 80px 0 20px');
    $header.css('height', '42px');
    $header.css('line-height', '42px');
    $header.css('border-bottom', '1px solid #eee');
    $header.css('font-size', '14px');
    $header.css('color', '#333');
    $header.css('overflow', 'hidden');
    $header.css('background-color', '#F8F8F8');
    $header.css('border-radius', '2px 2px 0 0');
    $header.html(this.options.title || '温馨提示');


    let $headerToolbar = $('<div class="header-toolbar"></div>');
    $headerToolbar.css('position', 'absolute');
    $headerToolbar.css('right', '15px');
    $headerToolbar.css('width', 'auto');
    $headerToolbar.css('height', 'auto');
    $headerToolbar.css('top', '15px');
    $headerToolbar.css('font-size', '0');
    $headerToolbar.css('line-height', 'initial');
    let $iconClose = $('<span class="lsiten-icon-close"></span>');
    $iconClose.css('background-position', '1px -40px');
    $iconClose.css('cursor', 'pointer');
    $iconClose.css('display', 'inline-block');
    $iconClose.css('vertical-align', 'top');
    $iconClose.css('position', 'relative');
    $iconClose.css('width', '16px');
    $iconClose.css('height', '16px');
    $iconClose.css('margin-left', '10px');
    $iconClose.css('font-size', '12px');


    $iconClose.on('click', function () {
      _this.hideMessage()
    });
    $headerToolbar.append($iconClose);
    this.$el.append($header);
    this.$el.append($headerToolbar);
  },
  _initStyledialog: function () {
    this.$el.css('background-color', this.options.backgroundColor)
            .css('top', '50%')
            .css('opacity', '1')
            .css('color', '#333')
            .css('left', '50%')
  },
  // message end  
  hideMessage: function () {
    this.$mask.hide();
    this.$el.hide();
  },
  showMessage: function (options) {
    if (typeof options === 'string') {
      this.message = options;
      this.type = 'message';
    } else if (typeof options === 'object') {
      this.options = Object.assign({}, this.options, options.options || {});
      this._initOptions();
      this.message = options.message || '';
    } else {
      console.log('参数错误！');
    }
    this._initShowMessage();
    this.$el.html('');
    this._initHeader();
    this._initBody();
    let _this = this;
    if (this.type === 'message') {
      this._initStylemessage();
      this.$el.show();
      if (this.settimeoutId) {
        clearTimeout(this.settimeoutId);
      } 
      this.settimeoutId = setTimeout(function() {
        _this.hideMessage();
      }, this.options.timeout);
    } else if (this.type === 'dialog') {
      if (this.settimeoutId) {
        clearTimeout(this.settimeoutId);
        this.hideMessage();
      } 
      this._initStyledialog();
      this.$mask.show();
      this.$el.show();
    }
  }
}
export default Message
