import $ from './dom-core';
import {isEmptyElement} from './util.js'
import {gennerOneLine} from './lineUtil.js'
let questionUtils = function () {

}

questionUtils.prototype = {
  constructor: questionUtils,
  /**
   * function 切分题目框
   * @param {DomElement} $border 题框
   * @param {Object} csize 栏size
   */
  _splitBorder: function ($border, csize) {
    let type = parseInt($border.attr('data-type'));
    switch (type) {
      case 1:
      return this._spiltObjectBorder($border, csize);
      break;
      case 2:
      return this._spiltSubjectBorder($border, csize);      
      break;
    }
  },
  /**
   * function 切分客观题框
   * @param {DomElement} $border 题框
   */
  _spiltObjectBorder: function ($border, csize) {
    let $nextBorder = $border.clone(false);
    let childs = $border.childNodes();
    let cLength = childs.length;
    if (cLength > 0) {
      let i = cLength - 1;
      while (i >= 0) {
        let bSizeBorder = $border.getSizeData();
        let row = childs[i];
        let $row = $(row);
        let $nextRow = $row.clone(false);
        if (bSizeBorder.bottom >= csize.bottom) {
          this._splitObjectRow($nextRow, $row, $border, csize);
          if ($nextRow.childNodes().length > 0) {
            if ($nextBorder.childNodes().length > 0) {
              let firstChildNode = $nextBorder[0].firstChild;
              $nextBorder[0].insertBefore($nextRow[0], firstChildNode);
              $(firstChildNode).removeClass('js-split-row' + (i+1));
              $nextRow.addClass('js-split-row' + i);
              $row.addClass('js-split-row'  + i)
            } else {
              $nextBorder.append($nextRow);
              $nextRow.addClass('js-split-row' + i);
              $row.addClass('js-split-row'  + i)
            }
          }
        }
        i--;
        if (!$row.childNodes().length) {
          $nextRow.removeClass('js-split-row' + i);
          $row.remove();
        }
      }
    }
    if (isEmptyElement($border[0])) {
      $border.remove();
    }
    if ($nextBorder.childNodes().length > 0) {
      $nextBorder[0].firstChild.style.borderTop = 'none';
      return $nextBorder;
    } else {
      return false;
    }
  },
  /**
   * function 处理客观题的row
   * @param {DomElement} $nextDiv 下一段的div
   * @param {DomElement} $item 文本节点
   * @param {DomElement} $border 所在框
   * @param {Object} csize 栏size
   */
  _splitObjectRow: function ($nextDiv, $item, $border, csize) {
    // debugger;
    let childs = $item.childNodes();
    let nextDivContentChilds =  [];
    let nextDivContentChildsLength =  0;
    nextDivContentChilds = $nextDiv.childNodes();
    nextDivContentChilds.length > 0 && (nextDivContentChildsLength = nextDivContentChilds.length);
    let cLength = childs.length;
    let firstColumn = childs[0];
    if (!firstColumn) {
      return '';
    }
    let $firstColumn = $(firstColumn);
    let lastQuestion = parseInt($firstColumn.attr('data-question-count')) - 1;
    lastQuestion < 0 ? lastQuestion = 0 : '';
    for (let i =0; i < cLength; i++) {
      let child = childs[i].firstChild; //栏下有一个内容div
      let $child = $(child);
      if (nextDivContentChildsLength > 0) {
        if (!nextDivContentChilds[i]) {
          console.log("%c数据错误！", "color:red");          
          return '';
        }
        let $nextContent = $(nextDivContentChilds[i].firstChild);
        let childsQuestion = $child.childNodes();
        let nextQuestion =  childsQuestion ? childsQuestion[lastQuestion] : null;
        if (nextQuestion) {
          $nextContent[0].insertBefore(nextQuestion, $nextContent[0].firstChild);
          let $childColumn = $(childs[i]);
          let columnQuestion = parseInt($childColumn.attr('data-question-count')) - 1;
          columnQuestion < 0 ? columnQuestion = 0: '';
          $childColumn.attr('data-question-count', columnQuestion);
        }
      } else {
        let $nextColum = $(childs[i]).clone(false);
        let $nextContent = $child.clone(false);
        let childsQuestion = $child.childNodes();
        let nextQuestion =  childsQuestion ? childsQuestion[lastQuestion] : null;
        if (nextQuestion) {
          $nextContent.append($(nextQuestion));
          let $childColumn = $(childs[i]);
          let columnQuestion = parseInt($childColumn.attr('data-question-count')) - 1;
          columnQuestion < 0 ? columnQuestion = 0: '';
          $childColumn.attr('data-question-count', columnQuestion);
          $nextColum.append($nextContent);
        } else {
          i === 0 ? $nextColum.append($child) : $nextColum.append($nextContent);
        }
        $nextDiv.append($nextColum);
      }

      if (i === 0) {
        let $columnPrev = $child;
        if (!$columnPrev.childNodes().length) {
          $item.html('');
        }
      }
    }
    if (firstColumn.firstChild) {
      let contentSize = $(firstColumn.firstChild).getSizeData();
      $item.find('.js-option-column').css('min-height', contentSize.height + 'px');
    }
    let bSizeBorder = $border.getSizeData();
    if (bSizeBorder.bottom >= csize.bottom) {
      this._splitObjectRow($nextDiv, $item, $border, csize);
    }

  },
  /**
   * function 插入dom
   * @param {DomElement}  $nextDom 下一栏暂存
   * @param {DomElement}  $dom 需要插入的dom
   */
  insertDom($nextDom, $dom) {
    let firstChild = $nextDom[0].firstChild;
    if (firstChild) {
      $dom.insertBefore($(firstChild));
    } else {
      $nextDom.append($dom);
    }
  },
    /**
   * function 切分主观题框
   * @param {DomElement} $border 题框
   * @param {Object} csize 栏size
   */
  _spiltSubjectBorder: function ($border, csize) {
    let $nextBorder = $border.clone(false);
    let $content = $($border[0].firstChild);
    if ($content.attr('class') === 'border-content') {
      let childrens = $content.childNodes();
      let $nextContent = $content.clone(false);
      let index = childrens.length - 1;
      while (index >= 0 ) {
        let line = childrens[index];
        if (line && line.className) {
          if (line.className.indexOf('js-lsiten-line') > -1) {
            // 普通一行或者是单选题可判断题
            let $line = $(line);
            let borderSize = $border.getSizeData();
            if (borderSize.bottom >= csize.bottom) {
              this.insertDom($nextContent, $line);
            }
          } else if (line.className.indexOf('js-lsiten-options-box') > -1) {
            // 选作题组
            let $line = $(line);
            let borderSize = $border.getSizeData();
            if (borderSize.bottom >= csize.bottom) {
              this.insertDom($nextContent, $line);
            }
          } else if (line.className.indexOf('js-lsiten-question') > -1) {
            let $line = $(line);
            let questionType = parseInt($line.attr('data-type'));
            switch (questionType) {
              case 1:
              this._handleChoice($line, $nextContent, csize);
              break;
              case 2:
              this._handleJudge($line, $nextContent, csize);              
              break;
              case 3:
              this._handleSubject($line, $nextContent, $border, csize);              
              break;
              case 4:
              this._handleWritting($line, $nextContent, $border, csize);              
              break;
            }
          }
        } else {
          line && $content[0].removeChild(line);
        }
        index--;
      }
      
      if (isEmptyElement($content[0])) {
        $border.remove();
      }
      if ($nextContent.childNodes().length > 0) {
        $nextBorder.append($nextContent);
        $border.addClass('js-split-border');
        $nextBorder.addClass('js-split-border');
        return $nextBorder;
      } else {
        return false;
      }

    } else {
      $border.remove();
      return false;
    }
  },
  /**
   * function 处理选择题div
   * @param {DomElement} $item 纯普通div
   * @param {DomElement} $nextContent 下一个框暂存
   * @param {Object} csize 栏size
   */
  _handleChoice: function ($item, $nextContent, csize) {
    let lineSize = $item.getSizeData();
    if (lineSize.top >= csize.bottom) {
      let newLine = gennerOneLine();
      newLine.append($item);
      $nextContent.append(newLine);
    }
  },
  /**
   * function 处理判断题div
   * @param {DomElement} $item 纯普通div
   * @param {DomElement} $nextContent 下一个框暂存
   * @param {Object} csize 栏size
   */
  _handleJudge: function ($item, $nextContent, csize) {
    let lineSize = $item.getSizeData();
    if (lineSize.top >= csize.bottom) {
      let newLine = gennerOneLine();
      newLine.append($item);
      $nextContent.append(newLine);
    }
  },
  /**
   * function 处理客观题Div
   * @param {DomElement} $item 纯普通div
   * @param {DomElement} $nextContent 下个框暂存
   * @param {DomElement} $border 所在框
   * @param {Object} csize 栏size
   */
  _handleSubject: function ($item, $nextContent, $border, csize) {
    let $nextSubject = $item.clone(false);
    let childs = $item.childNodes();
    let index = childs.length - 1;
    while (index >= 0 ) {
      let line = childs[index];
      if (line && line.className) {
        if (line.className.indexOf('js-lsiten-line') > -1) {
          // 普通一行
          let $line = $(line);
          let bSize = $border.getSizeData();
          if (bSize.bottom >= csize.bottom) {
            this.insertDom($nextSubject, $line);
          }
        } else {
          $(line).remove();
        }
      } else {
        line && $paragraph[0].removeChild(line);
      }
      index--;
    }

    if (isEmptyElement($item[0])) {
      $item.remove();
    }

    if ($nextSubject.childNodes().length > 0) {
      this.insertDom($nextContent, $nextSubject);
      $nextSubject.addClass('js-split-question');
      $item.addClass('js-split-question');
    }
  },
  /**
   * function 处理作文题Div
   * @param {DomElement} $item 纯普通div
   * @param {DomElement} $nextContent 下个框暂存
   * @param {DomElement} $border 所在框
   * @param {Object} csize 栏size
   */
  _handleWritting: function ($item, $nextContent, $border, csize) {
    let childs = $item.childNodes();
    let cLength = childs.length;
    let $nextWritting = $item.clone(false);
    if (cLength > 0) {
      let i = cLength - 1;
      while (i >= 0) {
        let bSize = $border.getSizeData();
        let child = childs[i];
        let $child = $(child);
        if (bSize.bottom >= csize.bottom) {
          if (child.className.indexOf('lsiten-title') > -1) {
            if (!isEmptyElement(child)) { 
              // 作文标题
              let $nextLsitenTitle = $child.clone(false);
              let titleChilds = $child.childNodes();
              let titleIndex = titleChilds.length - 1;
              while(titleIndex >= 0) {
                let line = titleChilds[titleIndex];
                if (line && line.className) {
                  if (line.className.indexOf('js-lsiten-line') > -1) {
                    // 普通一行
                    let $line = $(line);
                    bSize = $border.getSizeData();
                    if (bSize.bottom >= csize.bottom) {
                      this.insertDom($nextLsitenTitle, $line);
                    }
                  } else {
                    $(line).remove();
                  }
                } else {
                  line && $paragraph[0].removeChild(line);
                }
                titleIndex--;
              }
              if ($nextLsitenTitle.childNodes().length > 0) {
                this.insertDom($nextWritting, $nextLsitenTitle);
              }
            } else {
              $child.remove();
            }
          } else if (child.className.indexOf('lsiten-border-box') > -1){
            // 作文格子
            let $nextLsitenBorder = $child.clone(false);
            let rows = $child.childNodes();
            let rowLength = rows.length;
            if ( rowLength > 0 ) {
              let k = rowLength - 1;
              while ( k >= 0 ) {
                let bSizeBorder = $border.getSizeData();
                if (bSizeBorder.bottom >= csize.bottom) {
                  let $rowItem = $(rows[k]);
                  this.insertDom($nextLsitenBorder, $rowItem);
                }
                k--;
              }
            } else {
              $nextLsitenBorder.remove();
            }

            if ($nextLsitenBorder.childNodes().length > 0) {
              this.insertDom($nextWritting, $nextLsitenBorder);
              $nextLsitenBorder.addClass('js-split-writting-border');
            } 
          } else {
            $child.remove();
          }
        }
        i--;
        isEmptyElement($child[0]) && $child.remove();
      }
    }

    if ($nextWritting.childNodes().length > 0) {
      this.insertDom($nextContent, $nextWritting);
      $nextWritting.addClass('js-split-question');
      $item.addClass('js-split-question');
    }

    if (isEmptyElement($item[0])) {
      $item.remove();
    }
  }
}

export default questionUtils;
